//
// Created by n0ffie on 08/04/25.
//

#include <iostream>

#include <cigus.hpp>

class NewView : public cigus::UI::View {
public:
	void body() override {
		std::cout << "Hello World!" << std::endl;
		Rectangle();
	}
};

int main(int argc, char** argv) {

	namespace UI = cigus::UI;
	sf::RenderWindow window(sf::VideoMode({800, 600}), "Hello World!");
	window.setFramerateLimit(60);

	UI::Renderer renderer(cigus::Ref<UI::View>(new NewView()));

	while (window.isOpen()) {

		while (const std::optional event = window.pollEvent())
		{
			if (event->is<sf::Event::Closed>())
			{
				window.close();
			}
		}


		window.clear();
		renderer.render(window, sf::RenderStates());
		window.display();
	}
	renderer.destroy();

	return 0;
}